import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
var _excluded = ["name", "onChange", "onComplete", "mask", "value", "defaultValue"];
import { forwardRef, useEffect } from 'react';
import { useIMask } from 'react-imask';
import PropTypes from 'prop-types';
import useMergeRefs from '@s-ui/react-hooks/lib/useMergeRefs';
import Input from '../Input/Component/index.js';
import { jsx as _jsx } from "react/jsx-runtime";
var MaskInput = /*#__PURE__*/forwardRef(function (_ref, forwardedRef) {
  var name = _ref.name,
      onChange = _ref.onChange,
      _onComplete = _ref.onComplete,
      mask = _ref.mask,
      propValue = _ref.value,
      defaultValue = _ref.defaultValue,
      props = _objectWithoutPropertiesLoose(_ref, _excluded);

  var _useIMask = useIMask(_extends({}, mask), {
    onAccept: function onAccept(value, maskRef, event) {
      for (var _len = arguments.length, args = new Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
        args[_key - 3] = arguments[_key];
      }

      typeof onChange === 'function' && onChange(event, _extends({
        value: value,
        maskRef: maskRef
      }, args));
    },
    onComplete: function onComplete(value, maskRef, event) {
      for (var _len2 = arguments.length, args = new Array(_len2 > 3 ? _len2 - 3 : 0), _key2 = 3; _key2 < _len2; _key2++) {
        args[_key2 - 3] = arguments[_key2];
      }

      typeof _onComplete === 'function' && _onComplete(event, _extends({
        value: value,
        maskRef: maskRef
      }, args));
    }
  }),
      refInput = _useIMask.ref,
      _useIMask$value = _useIMask.value,
      maskedValue = _useIMask$value === void 0 ? '' : _useIMask$value,
      setValue = _useIMask.setValue;

  useEffect(function () {
    if (propValue !== maskedValue) {
      setValue(propValue);
    }
  }, [propValue, setValue, maskedValue]);
  var ref = useMergeRefs(refInput, forwardedRef);
  return /*#__PURE__*/_jsx(Input, _extends({
    ref: ref,
    id: name,
    value: maskedValue
  }, props));
});
MaskInput.displayName = 'MaskInput';
export default MaskInput;